#ifndef __GLOBAL_HEAP_H__
#define __GLOBAL_HEAP_H__

#include <cstdlib>
#include <pthread.h>
#include "allocator_util.h"
#include "memlib.h"


/* SUPERBLOCK STRUCT IN GLOBAL HEAP
 *
 * [size] = SUPERBLOCK_SIZE
 * [next]
 * [data]
 */

/* GlobalHeap
 * structure used by allocator
 */
class GlobalHeap
{
 public:
  GlobalHeap();
  ~GlobalHeap();
  int init();

  void *malloc(size_t size);
  void free(void *ptr);

  int check(); //checks correctness
 private:
  pthread_mutex_t globalMutex;  
  void *freeList; //sorted list of free super blocks

  void* getConsecutiveSuperBlocks(int n_superblocks);
  void returnMultipleSuperBlocks(void *first, void *last);
};

#endif //__GLOBAL_HEAP_H__
